.button {
    cursor: pointer;
    z-index: 1;
    font-size: 1rem;
    min-width: 10em;
    margin: 0.5em 0;
    overflow: hidden;
    position: relative;
    transition: all 0.25s;
    border: 1px solid $black;
    padding: 1rem 1rem;
    text-transform: uppercase;
    display: inline-flex;
    align-items: center;
    justify-content: space-between;

    @media (min-width: $lg) {
        padding: 1.15rem 1.15rem;
        min-width: 12.5em;
    }

    @media (min-width: $xl) {
        padding: 1.25rem 1.25rem;
        min-width: 15em;
    }

    &--arrow {
        border: 0;
        padding: 1em 0;
        min-width: 10em;
        padding-right: 0.5em;
        justify-content: flex-start;

        .arrow {
            margin-left: 5em;
        }

        &:hover {
            transition: all 0.25s;

            .arrow {
                width: 4em;
            }
        }
    }

    &--black {
        color: $white;

        &:after {
            content: "";
            position: absolute;
            left: 0;
            bottom: 0;
            width: 100%;
            z-index: -2;
            height: 100%;
            background-color: $black;
        }

        &:before {
            content: "";
            position: absolute;
            left: 0;
            bottom: 0;
            width: 0%;
            z-index: -1;
            height: 100%;
            transition: all 0.4s;
            background-color: $white;
        }

        .arrow {
            &:before {
                border-color: $white;
            }

            &:after {
                background-color: $white;
            }
        }

        &:hover {
            color: $black;

            &:before {
                width: 100%;
            }

            .arrow {
                &:before {
                    border-color: $black;
                }

                &:after {
                    background-color: $black;
                }
            }
        }
    }

    &--white {
        @extend .button--black;
        color: $black;

        &:before {
            background-color: $black;
        }

        &:after {
            background-color: $white;
        }

        .arrow {
            &:before {
                border-color: $black;
            }

            &:after {
                background-color: $black;
            }
        }

        &:hover {
            color: $white;

            &:before {
                width: 100%;
            }

            .arrow {
                &:before {
                    border-color: $white;
                }

                &:after {
                    background-color: $white;
                }
            }
        }
    }

    &--white-bordered {
        @extend .button--black;
        border: 1px solid $white;

        &:after {
            background-color: transparent;
        }
    }
}
